#!/usr/bin/env python

import httplib, os, re, time

import timeoutsocket
timeoutsocket.setDefaultSocketTimeout(30)

## Server class
class Server:
    """ The class that connects to each server. """
    def __init__(self, host):
        self.host = host

    def fetch(self, path):
        self.header(path) # Set self.http
        # Parse the information returned by the reply
        errcode, errmsg, headers = self.http.getreply()
        # Get the content
        content = self.http.getfile().read()
        return [errcode, headers, content]

    def header(self, path):
        self.http = httplib.HTTP(self.host)
        self.http.putrequest("GET", path)
        # User-Agent spoofed to make it look like this is a real browser.
        self.http.putheader("User-Agent", "Mozilla/5.0 (X11; U; Linux i686; en-US;)")
        self.http.putheader("Host", self.host)
        self.http.putheader("Accept", "*/*")
        self.http.endheaders()

def screen_shot(url):

    try:
        s = Server(url)
        info = s.fetch("/")
        full_url = "http://" + url + "/"

        test = str(info[1])
        matcher = re.compile("WWW-Authenticate: (.*)")
        mo = matcher.findall(test)
        if mo:
            return
        if info[0] >= 400:
            #trigger an exception
            raise
    except:
        s = Server("www." + url)
        try:
            info = s.fetch("/")
            full_url = "http://www." + url + "/"
            test = str(info[1])
            matcher = re.compile("WWW-Authenticate: (.*)")
            mo = matcher.findall(test)
            if mo:
                return
        except:
            return
    
    # You may need to adjust these        
#    firefox_cmd = "firefox-bin -remote openurl\('" + full_url + "'\)"
    firefox_cmd = "firefox -remote openurl\('" + full_url + "'\)"
    xwd_cmd = "xwd -frame -root -out screen.xwd"
    jpg_cmd = "xwdtopnm < screen.xwd | ppmtojpeg > ./img/" + url + ".jpg"


    os.system(firefox_cmd)
    # set it high enough
    time.sleep(20) 
    
    os.system(xwd_cmd)
    os.system(jpg_cmd)

# Read from file & process
input = "domains.txt"
input = open(input, "r")
lines = input.read().split("\n")
input.close()

# For each line of input
for domain in lines:
    screen_shot(domain)
